﻿/*===================================================================================================
                    Copyright(c) 2011 Siemens PLM Software Corp. All rights reserved.
                             Unpublished - All rights reserved
====================================================================================================
File description:
    
    Filename : epm_register_handler.c

    This file registers functions which are called when Teamcenter is being initialized

====================================================================================================
Date               Name                  Description of Change
2011-8-21			Ray               creation

$HISTORY$
==================================================================================================*/

#pragma warning (disable: 4819) 

/**
* @headerfile			tcua 头文件
*/
#include <server_exits/user_server_exits.h>
#include <tccore/custom.h>
#include <tccore/item_msg.h>
#include <epm/epm.h>

/**
* @headerfile			standard c & cpp header files
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <tccore/method.h>
#include <tccore/tc_msg.h>


/**
* @headerfile			user's header files
*/
#include "epm_register_handler.h"
#include "mdbks_register.h"
#include "connor_itk_util.h"
#define LIMITDAY 2016

int checkvalue(char* str)
{
    
    int i;
    for (i=0;i<strlen(str);i++)
    {
        if (isdigit(str[i]) == 0)
			return 0;
    }
    return 1;
}

char* decrypt(char *lic_file)
{
	char* p = NULL, buf[512], *str;
	int i = 0;

	FILE *fp1=NULL;
	if((fp1 = fopen(lic_file,"r")) == NULL)
	{
		printf("can not open the license file\n");
		return "";
	}
	fgets(buf, 9, fp1);
	//printf("buf=%s\n",buf);
	p = buf;
	while(*p != '\0')
	*p++ ^= i++;
	p = buf;
	while(*p != '\0')
	*p++ ^= i++;
	p = buf;
	while(*p != '\0')
	*p++ ^= i++;
	return buf;
}
char* encrypt(char* str)
{
 char* p = str;
 int i = 0;
 while(*p != '\0')
  *p++ ^= i++;
 return str;
}

//供流程调用的
//标准的注册供流程调用服务handler的入口 TC_save_msg
extern DLLAPI int USERSERVICE_custom_register_handlers(int *decision, va_list args)
{


	char* log_file = NULL;

	printf("创建日志文件\n");
	char* TO_SRM = (char*)malloc(sizeof("TO_SRM"));
	strcpy(TO_SRM, "TO_SRM");
	CreateLogFile(TO_SRM, &log_file);

	int ifail = ITK_ok, n = 0;
	char date_buf[80], * expire_date, env[512], temp1[512], temp2[512];
	time_t now;
	struct   tm* p;

	*decision = ALL_CUSTOMIZATIONS;

	int status = ITK_ok;

	//物料传递MES
	(ifail = EPM_register_action_handler("KSDY_Material2MES", "KSDY_Material2MES", (EPM_action_handler_t)KSDY_Material2MES));
	if (ifail == 0) {
		WriteLog("Registering action handler KSDY_Material2MES successful\n");
	}
	else {
		WriteLog("Registering action handler KSDY_Material2MES failed %d\n", ifail);
	}

	//图纸传递MES
	(ifail = EPM_register_action_handler("KSDY_DrawToMES", "KSDY_DrawToMES", (EPM_action_handler_t)KSDY_DrawToMES));
	if (ifail == 0) {
		WriteLog("Registering action handler KSDY_DrawToMES successful\n");
	}
	else {
		WriteLog("Registering action handler KSDY_DrawToMES failed %d\n", ifail);
	}




	CloseLog();
	return ifail;

}


//int Connor_set_bypass(void* returnValue)
//{
//	POM_AM__set_application_bypass(true);
//	return  0;
//}
//
//int Connor_close_bypass(void* returnValue)
//{
//	POM_AM__set_application_bypass(false);
//	return  0;
//}

////根据传过来的对象 修改单位
//int connor_set_uom(void* returnValue) {
//	int ifail = ITK_ok;
//	tag_t tag = NULL_TAG;
//	char* uomName = NULL;
//	tag_t* release_objs = NULL;
//
//	USERARG_get_tag_argument(&tag);
//	USERARG_get_string_argument(&uomName);
//
//	int num_could = 0;
//	tag_t* uoms = NULL, uom = NULLTAG;
//	ITKCALL(UOM_extent(&num_could, &uoms));
//	for (int i = 0; i < num_could; i++)
//	{
//		char* name = NULL;
//		UOM_ask_name(uoms[i], &name);
//		if (strcmp(name, uomName) == 0)
//		{
//			uom = uoms[i];
//			break;
//		}
//	}
//	char* class_id = NULL;
//	tag_t attr_id = NULLTAG, class_tag = NULLTAG, tag_instance = NULLTAG;
//	ITKCALL(AOM_lock(tag));
//	ITKCALL(POM_class_of_instance(tag, &class_tag));
//	ITKCALL(POM_name_of_class(class_tag, &class_id));
//	ITKCALL(POM_attr_id_of_attr("uom_tag", class_id, &attr_id));
//	ITKCALL(POM_refresh_instances_any_class(1, &tag, POM_modify_lock));
//	ITKCALL(POM_set_attr_tag(1, &tag, attr_id, uom));
//	ITKCALL(POM_save_instances(1, &tag, true));
//	ITKCALL(AOM_unlock(tag));
//	ITKCALL(AOM_refresh(tag, false));
//	
//	return ITK_ok;
//}

//定义JAVA调用的服务
//register service method
extern DLLAPI int USERSERVICE_custom_register_methods(int* decision, va_list args)
{

	
	int
		status = ITK_ok,
		numberOfArguments = 0,
		returnValueType = USERARG_STRING_TYPE,
		* argumentList = NULL;
	USER_function_t functionPtr;

	////开旁路
	//numberOfArguments = 1;
	//functionPtr = Connor_set_bypass;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	//argumentList[0] = USERARG_STRING_TYPE;
	////定义返回值的类型
	//returnValueType = USERARG_VOID_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("Connor_set_bypass", functionPtr, numberOfArguments,
	//	argumentList, returnValueType));
	//MEM_free(argumentList);
	//if (status == ITK_ok)
	//{
	//	fprintf(stdout, "\n Registering Connor_set_bypass finished\n");
	//}
	//else
	//{
	//	fprintf(stdout, "\n Registering Connor_set_bypass failed %d\n", status);
	//}

	////关旁路
	//numberOfArguments = 1;
	//functionPtr = Connor_close_bypass;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	//argumentList[0] = USERARG_STRING_TYPE;
	//returnValueType = USERARG_VOID_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("Connor_close_bypass", functionPtr, numberOfArguments,
	//	argumentList, returnValueType));
	//MEM_free(argumentList);
	//if (status == ITK_ok)
	//{
	//	fprintf(stdout, "\n Registering Connor_close_bypass finished\n");
	//}
	//else
	//{
	//	fprintf(stdout, "\n Registering Connor_close_bypass failed %d\n", status);
	//}


	////根据传过来的id和单位，修改单位
	//numberOfArguments = 2;
	//functionPtr = connor_set_uom;
	//argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	//argumentList[0] = USERARG_TAG_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE;
	//returnValueType = USERARG_VOID_TYPE;
	//ITKCALL(status = USERSERVICE_register_method("connor_set_uom", functionPtr, numberOfArguments,
	//	argumentList, returnValueType));
	//MEM_free(argumentList);
	//if (status == ITK_ok)
	//{
	//	fprintf(stdout, "\n Registering connor_set_uom finished\n");
	//}
	//else
	//{
	//	fprintf(stdout, "\n Registering connor_set_uom failed %d\n", status);
	//}

	return 0;
}





